Programming MQSeries with Visual Basic

Rommel  Abdon
Senior Support Engineer
Client Server Technologies (The Philippines)	c Xephon 1999



Option Explicit
Dim gHconn As Long
Dim gHobj  As Long

Private Sub Form_Load()
    Dim CompCode As Long
    Dim Reason   As Long
    
    '=========================
    'Initialize the structures
    '=========================
    MQ_SETDEFAULTS
    
    '====================================
    'Connect to the default queue manager
    '====================================
    MQCONN "", gHconn, CompCode, Reason
    
    '========================================================
    'If there is a failure, report reason and end application
    '========================================================
    If CompCode = MQCC_FAILED Then
        If Reason = 2059 Then
            MsgBox "Cannot connect to queue manager.", vbOKOnly, _
                   "Reason(2059)  MQRC_Q_MGR_NOT_AVAILABLE"
        End If
    End If
End Sub

Private Sub cmdOpen_Click()
    Dim OpenOpts  As Long
    Dim ObjDesc   As MQOD
    Dim CompCode  As Long
    Dim Reason    As Long
    
    '=======================================================
    'If the connect was successful, open the queue specified
    'in the queue textbox
    '=======================================================
    If gHconn Then
        MQOD_DEFAULTS ObjDesc
        
        ObjDesc.ObjectName = UCase(QueueNm.Text) 'change to queue names
                                                 'to uppercase
    
        OpenOpts = MQOO_OUTPUT + MQOO_FAIL_IF_QUIESCING
        
        MQOPEN gHconn, ObjDesc, OpenOpts, gHobj, CompCode, Reason
        
        '=========================
        'If not successful, report the reason
        '=========================
        If CompCode <> MQCC_OK Then Beep
            If Reason = 2085 Then
               MsgBox "Unable to open the Queue. ", vbOKOnly, _
                      "ReasonCode = (2085) - MQRC_UNKNOWN_OBJECT_NAME"
            End If
    
            If Reason = 2087 Then Beep
                MsgBox "Unable to open the Queue.", vbOKOnly, _
                       "ReasonCode = (2087) - MQRC_REMOTE_Q_MGR"
            End If
        Else
            cmdOpen.Enabled = False
            cmdClose.Enabled = True
            cmdPut.Enabled = True
        End If
    End If
End Sub

Private Sub cmdPut_Click()
    Dim MsgDesc     As MQMD
    Dim PutMsgOpt   As MQPMO
    Dim buflen      As Long
    Dim buffer      As String
    Dim CompCode    As Long
    Dim Reason      As Long
    
    '==============================================================
    'Initialize and setup MQMD and MQPMO to their respective values
    '==============================================================
    
    MQMD_DEFAULTS MsgDesc
    MsgDesc.Format = MQFMT_STRING   'format message as string
    
    MQPMO_DEFAULTS PutMsgOpt
    
    '========================================================
    'Get the message from the text box to be put to the queue
    '========================================================
    buflen = Len(txtPut.Text)
    buffer = txtPut.Text
    MQPUT gHconn, gHobj, MsgDesc, PutMsgOpt, buflen, buffer, _
          CompCode, Reason
    
    '===============================================================
    'To see the messages you put, add the message to the Log listbox
    '===============================================================
    listLog.AddItem buffer
    listLog.ListIndex = listLog.ListCount - 1
    
    If CompCode <> MQCC_OK Then Beep
End Sub
    
Private Sub cmdClose_Click()
    Dim CloseOpts As Long
    Dim CompCode As Long
    Dim Reason As Long

    '======================================
    'Close the queue if opened successfully
    '======================================
    If gHobj Then
        CloseOpts = 0
        MQCLOSE gHconn, gHobj, CloseOpts, CompCode, Reason

        If CompCode <> MQCC_OK Then
            Beep
            MsgBox "MQCLOSE ended with Reason Code = " + _
                    Str(Reason), vbOKOnly, "Error on Close"
        Else
            cmdOpen.Enabled = True
            cmdClose.Enabled = False
            cmdPut.Enabled = False
        End If
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim CompCode As Long      'completion code
    Dim Reason As Long        'reason code

    '=========================================================
    'If queue manager connected successfully - then disconnect
    '=========================================================

    If gHconn Then
        MQDISC gHconn, CompCode, Reason
        If CompCode <> MQCC_OK Then
            MsgBox "MQDISC ended with Reason Code = " + _
                    Str(Reason), vbOKOnly, "Error on Disconnect"
    End If
End Sub


